---
title: TypedArray.prototype.reduceRight()
slug: Web/JavaScript/Reference/Global_Objects/TypedArray/reduceRight
tags:
  - JavaScript
  - Method
  - Prototype
  - Reference
  - TypedArray
  - TypedArrays
---
<div>{{JSRef}}</div>

<p>The <strong><code>reduceRight()</code></strong> method applies a function against an accumulator and each value of the typed array (from right-to-left) has to reduce it to a single value. This method has the same algorithm as {{jsxref("Array.prototype.reduceRight()")}}. <em>TypedArray</em> is one of the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/TypedArray#TypedArray_objects">typed array types</a> here.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>typedarray</var>.reduceRight(<var>callback</var>[, <var>initialValue</var>])</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>callback</var></code></dt>
 <dd>Function to execute on each value in the typed array, taking four arguments:
 <dl>
  <dt><code><var>previousValue</var></code></dt>
  <dd>The value previously returned in the last invocation of the callback, or <code>initialValue</code>, if supplied (see below).</dd>
  <dt><code><var>currentValue</var></code></dt>
  <dd>The current element being processed in the typed array.</dd>
  <dt><code><var>index</var></code></dt>
  <dd>The index of the current element being processed in the typed array.</dd>
  <dt><code><var>array</var></code></dt>
  <dd>The typed array <code>reduceRight()</code> was called upon.</dd>
 </dl>
 </dd>
 <dt><code><var>initialValue</var></code></dt>
 <dd>Optional. Object to use as the first argument to the first call of the <code><var>callback</var></code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The value that results from the reduction.</p>

<h2 id="Description">Description</h2>

<p>The <code>reduceRight</code> method executes the <code><var>callback</var></code> function once for each element present in the typed array, excluding holes in the typed array, receiving four arguments: the initial value (or value from the previous <code><var>callback</var></code> call), the value of the current element, the current index, and the typed array over which iteration is occurring.</p>

<p>The call to the <code>reduceRight</code> callback would look something like this:</p>

<pre class="brush: js notranslate">typedarray.reduceRight(function(previousValue, currentValue, index, typedarray) {
  // ...
});
</pre>

<p>The first time the function is called, the <code><var>previousValue</var></code> and <code><var>currentValue</var></code> can be one of two values. If an <code><var>initialValue</var></code> was provided in the call to <code>reduceRight</code>, then <code><var>previousValue</var></code> will be equal to <code><var>initialValue</var></code> and <code><var>currentValue</var></code> will be equal to the last value in the typed array. If no <code><var>initialValue</var></code> was provided, then <code><var>previousValue</var></code> will be equal to the last value in the typed array and <code><var>currentValue</var></code> will be equal to the second-to-last value.</p>

<p>If the typed array is empty and no <code><var>initialValue</var></code> was provided, {{jsxref("TypeError")}} would be thrown. If the typed array has only one element (regardless of position) and no <code><var>initialValue</var></code> was provided, or if <code><var>initialValue</var></code> is provided but the typed array is empty, the solo value would be returned without calling <code><var>callback</var></code>.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Sum_up_all_values_within_an_array">Sum up all values within an array</h3>

<pre class="brush: js notranslate">var total = new Uint8Array([0, 1, 2, 3]).reduceRight(function(a, b) {
  return a + b;
});
// total == 6
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-%typedarray%.prototype.reduceright', '%TypedArray%.prototype.reduceRight')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.TypedArray.reduceRight")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("TypedArray.prototype.reduce()")}}</li>
 <li>{{jsxref("Array.prototype.reduceRight()")}}</li>
</ul>
